#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

typedef struct _grad{
    char ime[51];
    double x,y;
    int zarada;
    struct _grad *next;
}grad;

double tezinski_koef(grad* first, grad* novi)
{
    return novi->zarada/sqrt((first->x-novi->x)*(first->x-novi->x)
        +(first->y-novi->y)*(first->y-novi->y))
        +first->next->zarada/sqrt((first->next->x-novi->x)*(first->next->x-novi->x)
        +(first->next->y-novi->y)*(first->next->y-novi->y));
}

int udaljenost(grad* pom, double x, double y, double rad)
{
    if((x-pom->x)*(x-pom->x)+(y-pom->y)*(y-pom->y)<=rad*rad)
        return 1;
    return 0;
}

grad* organiziraj_put(grad* first, grad* novi)
{
    double max;
    grad *pokmax, *pom;   //element nakon kojeg dodajemo novi

    if(!first){ //ulazna lista je prazna
        novi->next=NULL;
        return novi;
    }

    if(!first->next){   //ulazna lista ima samo jedan element
        first->next=novi;
        novi->next=NULL;
        return first;
    }

    pokmax=first;
    max=tezinski_koef(first,novi);
    for(pom=first; pom->next->next; pom=pom->next){
        if(tezinski_koef(pom,novi)>max){
            max=tezinski_koef(pom,novi);
            pokmax=pom;
        }
    }

    novi->next=pokmax->next;
    pokmax->next=novi;

    return first;
}

grad* odvoji(grad** first, char* ime, double rad)
{
    grad *pom, *firstnew=NULL, *pom2;
    double xsred, ysred;
    int postoji=0;

    for(pom=*first; pom; pom=pom->next){
        if(!strcmp(ime,pom->ime)){
            xsred=pom->x;
            ysred=pom->y;
            postoji=1;
            break;
        }
    }
    if(!postoji)
        return NULL;

    while(*first && udaljenost(*first,xsred,ysred,rad)){   //brisanje s pocetka
        pom=*first;
        *first=(*first)->next;
        firstnew=organiziraj_put(firstnew,pom);
    }

    for(pom=*first; pom->next=NULL; ){
        if(udaljenost(pom->next,xsred,ysred,rad)){
            pom2=pom->next;
            pom->next=pom2->next;
            firstnew=organiziraj_put(firstnew,pom2);
        }
        else
            pom=pom->next;
    }

    return firstnew;
}

int main(void)
{
    return 0;
}
